# TPK4186 - Advanced Tools for Performance Engineering
# aggregators.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

import random

def Sum(values):
  sum = 0.0
  for value in values:
    sum += value
  return sum

def Product(values):
  product = 1.0
  for value in values:
    product *= value
  return product

def Minimum(values):
  minimum = float("inf")
  for value in values:
    if value<minimum:
      minimum = value
  return minimum

def Maximum(values):
  maximum = -float("inf")
  for value in values:
    if value>maximum:
      maximum = value
  return maximum

def Mean(values):
  if len(values)==0:
    return 0.0
  sum = Sum(values)
  return sum/len(values)

values = [i for i in range(1, 11)]
random.shuffle(values)
print("values = " + str(values))
print("sum = " + str(Sum(values)))
print("product = " + str(Product(values)))
print("minimum = " + str(Minimum(values)))
print("maximum = " + str(Maximum(values)))
print("mean = " + str(Mean(values)))

