# TPK4186 - Advanced Tools for Performance Engineering
# CharacterFrequencies.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

def ImportFile(fileName, frequencies):
  try:
    file = open(fileName, "r")
  except:
    print("Unable to open file " + fileName)
    return
  for line in file:
    line = line.rstrip()
    for c in line:
      c = c.lower()
      count = frequencies.get(c, 0)
      count += 1
      frequencies[c] = count
  file.close()

def PrintFrequencies(frequencies):
  for c in sorted(frequencies, key=frequencies.get, reverse=True):
    print(c + "\t" + str(frequencies[c]))
    
frequencies = dict()
ImportFile("Lorem Ipsum.txt", frequencies)
#ImportFile("Universal Declaration of Human Rights.txt", frequencies)
PrintFrequencies(frequencies)