# TPK4186 - Advanced Tools for Performance Engineering
# Quicksort.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

# Required modules
import sys
import random

# Splitting a list
def Split(pivot, elements):
  smallerElements = []
  biggerElements = []
  for element in elements:
    if element<pivot:
      smallerElements.append(element)
    else:
      biggerElements.append(element)
  return (smallerElements, biggerElements)

# Quicksort
def Quicksort(elements):
  if len(elements)<=1:
    return elements[:]
  pivot = elements.pop()
  (smallerElements, biggerElements) = Split(pivot, elements)
  elements.append(pivot)
  sortedSmallerElements = Quicksort(smallerElements)
  sortedBiggerElements = Quicksort(biggerElements)
  sortedElements = sortedSmallerElements
  sortedElements.append(pivot)
  sortedElements.extend(sortedBiggerElements)
  return sortedElements
  

# Creation of the source list
random.seed(12345)
sourceList = [random.uniform(0.0, 1.0) for i in range(0, 100)]
print(sourceList)

targetList = Quicksort(sourceList)
print(targetList)
