# TPK4186 - Advanced Tools for Performance Engineering
# selectors.py
# by Antoine Rauzy
# Copyrights (c) 2019-2020 NTNU
#
# This file is part of the educational material provided to NTNU students registered to the course TPK4186.
# It is licensed under a Creative Commons Attribution-NonCommercial 4.0 International License.
# For details about this license, see https://creativecommons.org/licenses/by-nc/4.0/.

def OddsAndEvens(values):
  odds = []
  evens = []
  for value in values:
    if value%2==0:
        evens.append(value)
    else:
        odds.append(value)
  return (odds, evens)

def OneOutOfK(values, k):
  selected = []
  rejected = []
  count = 0
  for value in values:
    count += 1
    if count%k==0:
        selected.append(value)
    else:
        rejected.append(value)
  return (selected, rejected)


def KBest(values, k):
  copy = values[:]
  copy.sort()
  copy.reverse()
  return copy[0:k]

values = [i for i in range(1, 11)]
random.shuffle(values)
print("values = " + str(values))
(odds, evens) = OddsAndEvens(values)
print("odds = " + str(odds))
print("evens = " + str(evens))

(selected, rejected) = OneOutOfK(values, 2)
print("selected = " + str(selected))
print("rejected = " + str(rejected))

(selected, rejected) = OneOutOfK(values, 3)
print("selected = " + str(selected))
print("rejected = " + str(rejected))

best = KBest(values, 3)
print("best = " + str(best))
